



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>openssl证书制作详细教程</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">openssl证书制作详细教程</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 16:57:16 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>自签名证书及验证</h1>
<h2>模拟证书涉及的角色</h2>
<ol><li>创建证书目录<br />
<code>mkdir ~/certs   cd ~/certs</code></li>
<li>认证机构、网站、浏览器/用户<br />
<code>mkdir root web user</code></li></ol>
<h2>机构自签名证书生成和发布</h2>
<ol><li>生成私钥<br />
<code>cd root</code><br />
<code>openssl genrsa -des3 -out rootCA.key 2048</code></li>
<li>用私钥生成自签证书<br />
<code>openssl req -x509 -new -nodes -key rootCA.key  -out rootCA.cert</code></li>
<li>发布证书<br />
<code>cp rootCA.cert ../web ../user</code><br />
模拟证书发布到用户和网站的过程</li></ol>
<h2>给网站签署证书</h2>
<h3>由网站生成证书请求</h3>
<ol><li>网站生成私钥<br />
<code>cd ../web</code><br />
<code>openssl genrsa -des3 -out web.org.key 2048</code></li>
<li>去除私钥密码<br />
<code>openssl rsa -in web.org.key -out web.key</code></li>
<li>生成证书签名请求<br />
<code>openssl req -new -key web.key -out web.csr</code></li>
<li>请求证书发给机构<br />
<code>cp web.csr ../root</code></li></ol>
<h3>机构签署证书</h3>
<ol><li>签署<br />
<code>cd ../root</code><br />
<code>openssl x509 -req -days 365 -in web.csr -CAkey rootCA.key -CA rootCA.cert -CAcreateserial -out web.crt</code></li>
<li>签署后的证书 web.crt 发回给网站<br />
<code>cp web.crt ../web</code></li></ol>
<h3>网站将证书挂到https服务器</h3>
<p>这一步请移步参考各https容器配置</p>
<h2>用户访问web网站</h2>
<ol><li>模拟用户从网站下载证书<br />
<code>cd ../user</code><br />
<code>cp ../web/web.crt .</code></li>
<li>验证网站证书的合法性<br />
<code>openssl verify -CAfile rootCA.cert -ca-bundle web.crt</code><br />
rootCA.cert是机构发布，并得到用户得到信任的根证书，用此证书验证web.crt的合法性。</li></ol>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93yoon8.html">CJCMS系列--demo代码篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/4950m3v8.html">Android UI自动化用例设计技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx6owvq.html">使用html2canvas实现批量生成条形码</a>
		</li>
						<li><a href="https://www.batexi.com/a/4957e0mq.html">当子查询碰上NULL</a>
		</li>
						<li><a href="https://www.batexi.com/a/39010vj8.html">理解Java中字符流与字节流的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/495ly6z8.html">mac OS X操作 --  常用</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jwkl08.html">Applying Eigenvalues to the Fibonacci Problem</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gne348.html">星外虚拟主机跨web目录文件读取漏洞</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx0l6jq.html">Data Plane Development Kit &lpar;DPDK&rpar;&colon; Getting Started</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjw12k9.html">xml中俩种解析方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjpg6d9.html">MongoDB数据库的主从配对与迁移示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z16ny19.html">DrawWindowFrame</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e176wk9.html">Codeforces Round &num;197 &lpar;Div&period; 2&rpar; &colon; D</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxko1xe8.html">EF&plus;SQLSERVER控制并发下抢红包减余额（改进）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pwkdj8.html">ubuntu11&period;04安装nginx&plus;php&plus;mysql</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwpg6j9.html">Excel VBA 连接各种数据库（二） VBA连接Oracle数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o4mrk8.html">MySQL Workbench常用快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pggl3q.html">PgSQL基础之   安装postgresql数据系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7empxe9.html">android  多进程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rngdg7q.html">JVM进程cpu飙高分析</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r937le08.html">mysql5&period;8安装指南</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gg6nl9.html">用JS做的时钟</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyg3dmq.html">Erlang 从入门到精通（三） 改变工作目录</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7d16kq.html">tomcat启动时 myeclipse控制台中文乱码</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k2e2j8.html">JavaScript内置对象之数组</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pgrnk9.html">C&plus;&plus; --- Hellowrod</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mk002q.html">ASP&period;NET应用中会话状态丢失及解决策略</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvk6vo9.html">C&plus;&plus;读写文件ofstream&comma;ifstream&comma;fstream）&lbrack;转&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxypzz9.html">&lbrack;刘阳Java&rsqb;&lowbar;避开环境配置快速的使用Java的开发工具&lowbar;第5讲</a>
			</li>
						<li><a href="https://www.batexi.com/a/r937e4g8.html">treap树模板</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
